/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */

var Entaxy;
(function (Entaxy) {
    Entaxy._module.factory('entaxyHotkeysService', ['hotkeys',
        function(hotkeys) {

            let hotkeysCache = {};

            return {
                setHotkeys: function (scope, hotkeysConfigs) {
                    return setHotkeys(scope, hotkeysConfigs);
                }
            };

            function setHotkeys(scope, hotkeysConfigs) {
                let bindTo;

                hotkeysConfigs.forEach(hotkeyConfig => {
                    let actionConfig = {
                        scopeId: scope.$id,
                        action: hotkeyConfig.callback
                    };

                    if (!hotkeys.get(hotkeyConfig.combo)) {
                        if (!bindTo) {
                            bindTo = hotkeys.bindTo(scope);
                        }
                        hotkeysCache[hotkeyConfig.combo] = [ actionConfig ];
                    } else {
                        hotkeysCache[hotkeyConfig.combo].push(actionConfig);
                    }

                    scope.$on('$destroy', function() {
                        hotkeysCache[hotkeyConfig.combo] = hotkeysCache[hotkeyConfig.combo]
                            .filter(actionConf => actionConf.scopeId !== scope.$id);
                        if (hotkeysCache[hotkeyConfig.combo].length == 0) {
                            delete hotkeysCache[hotkeyConfig.combo];
                        }
                    });

                    hotkeyConfig.callback = function (event, hotkey) {
                        event.preventDefault();
                        performAction(event, hotkey.combo);
                    }

                    if (bindTo) {
                        bindTo = bindTo.add(hotkeyConfig);
                    }
                });
            }

            function performAction(event, hotkey) {
                if (hotkeysCache[hotkey]) {
                    let actions = hotkeysCache[hotkey];
                    let action = actions.slice(-1)[0].action;

                    if (action) {
                        action(event);
                    }
                }
            }
        }
    ]);
})(Entaxy || (Entaxy = {}));
